
#include "header.h"

#define BLOCK_SIZE  1024

extern void LoadFileTo();

extern char dummySCB[];

#asm

_dummySCB:        	dc.b $00,$10,$00
					dc.w 0,dummy_data
					dc.w 0,0
;					dc.w $100,$500 ; // $0D0,$400
					dc.w $0D0,$400
_dummy_color:     	dc.b $00

; data: 5*1 pixel
dummy_data        dc.b 2,$24,0


#endasm



extern set_VBL75();
extern set_VBL60();

extern uchar vbl_count, vbl_count2;

#define FILE_CHIP		2

#define MEM_CHIP		0x8000

load_lynxchip()
{
  LoadFileTo(FILE_CHIP,MEM_CHIP);
}

extern SndInit();
extern SndStart();
extern SndStop();

lynxchip_init()
{
  SndInit();
  SndStart();
}

VBL2() interrupt
{
#asm
	stz _VBLflag ; /* indicates that a VBL has ocurred */
	inc _vbl_count
	inc _vbl_count2
#endasm
}

// 8 Bit
extern uchar Random256(void);
extern uchar random_bit(void);
extern char WaitButton();

extern void wait_delay(); // char d

extern void set_text_color(); // char a

extern void CLS();// char nColor

#define VSYNC {++VBLflag;while( VBLflag );}


char pal[]={
	0x00,0x00,0x08,0x08,0x00,0x00,0x08,0x0C,0x08,0x00,0x0F,0x0F,0x00,0x00,0x0F,0x0F,
	0x00,0x08,0x00,0x08,0x80,0x88,0x80,0xCC,0x88,0x0F,0x00,0x0F,0xF0,0xFF,0xF0,0xFF};

/****************************************/
/* Paints the screen                    */
/****************************************/

void jeden_vbl(void)
{
	SwapBuffers();
	VSYNC;
	CLS(0);
}


void game_main(void)
{
  uchar joy;
  uchar alt_joy;

  alt_joy=0;
  jeden_vbl();
  vbl_count=0;
  lynxchip_init();
  while(1){
	jeden_vbl();

	joy=joystick;
	if(joy==alt_joy) joy=0;
    	alt_joy=joy;
	if(joy&0xAA){
		SndStop();
	}else if(joy&0x55){
		SndStop();
		SndStart();
	}
  }
}

void init_game()
{

}

/****************************************/
/*              M  A  I  N              */
/****************************************/

void main(void)
{
	set_VBL60();
	InitIRQ();

	CLI;
	load_lynxchip();
	InstallIRQ(2,VBL2);
	SetBuffers(SCREEN_1, SCREEN_1, 0x0);// 1, 2
	EnableIRQ(2);
	set_VBL75();
   CLS;
   _SetRGB(pal);
	
   SwapBuffers();

	
   while(1)
	{
	  init_game();
      game_main();

	  if( joystick&BUTTON_OPTION1 &&  switches&0x1) break; 
   }
#asm
  sei
  stz $FFF9
  jmp $FE00
#endasm
}


